 if not exist %TEMP_WAV% goto wav_not_exist

.\MediaInfo.exe --Inform=Audio;%%SamplingRate%% --LogFile=%TEMP_INFO% %TEMP_WAV%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a SAMPLERATE=%%i

if %SAMPLERATE% GTR %MAX_SAMPLERATE% (
       echo %SAMPLERATE_ALERT%
       echo Original  : %SAMPLERATE% bps
       echo Converted : %MAX_SAMPLERATE% bps
)


rem GR[h
if /i "%AAC_PROFILE%"=="auto" (
    goto auto_profile
) else if /i "%AAC_PROFILE%"=="lc" (
    set AAC=-lc
) else if /i "%AAC_PROFILE%"=="he" (
    set AAC=-he
)@else if /i "%AAC_PROFILE%"=="hev2" (
    set AAC=-hev2
)

:auto_profile
if %A_BITRATE% LEQ 32 (
    set AAC=-hev2
) else if %A_BITRATE% LEQ 96 (
    set AAC=-he
) else (
    set AAC=-lc
)

(
    echo WAVSource^("%TEMP_WAV%"^)
    echo;
    if %SAMPLERATE% GTR %MAX_SAMPLERATE% (
       echo ResampleAudio^(%MAX_SAMPLERATE%^)
    )
    echo;
    echo return last
)> %AUDIO_AVS%

if /i "%A_SYNC%"=="n" (
    .\wavi.exe %AUDIO_AVS% %FINAL_WAV% 1>nul 2>&1
    goto m4a_encode
)
if /i "%A_SYNC%"=="y" goto auto_sync

set M4A_LAG=%A_SYNC%
goto wav_avs

:auto_sync
if /i "%AAC_ENCODER%"=="qt" (
    .\wavi.exe %AUDIO_AVS% %FINAL_WAV% 1>nul 2>&1
    goto m4a_encode
)

rem YC
:sync_gap
echo ^>^>%SYNC_ANNOUNCE%
if exist %PROCESS_E_FILE% del %PROCESS_E_FILE%
echo s>%PROCESS_S_FILE%
start /b process.bat 2>nul
.\wavi.exe %AUDIO_AVS% - 2>nul | .\neroAacEnc.exe %AAC% -ignorelength -br %A_BITRATE%000 -if - -of %TEMP_M4A% 1>nul 2>&1
.\MediaInfo.exe --Inform=General;%%PlayTime%% --LogFile=%TEMP_INFO% %TEMP_M4A%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set M4A_TIME=%%i
.\MediaInfo.exe --Inform=General;%%PlayTime%% --LogFile=%TEMP_INFO% %TEMP_WAV%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set WAV_TIME=%%i
set /a M4A_LAG_TEMP=%M4A_TIME%-%WAV_TIME%
set /a M4A_LAG=-%M4A_LAG_TEMP%/2
del %PROCESS_S_FILE% 2>nul
:sync_process
ping localhost -n 1 >nul
if not exist %PROCESS_E_FILE% goto sync_process 1>nul 2>&1
del %PROCESS_E_FILE%

:wav_avs
(
    echo WAVSource^("%TEMP_WAV%"^)
    echo;
    echo ResampleAudio^(%SAMPLERATE%^)
    echo;
    echo _lag = Float^(%M4A_LAG%^) / 1000
    echo DelayAudio^(_lag^)
    echo;
    echo return last
)> %AUDIO_AVS%

echo ^>^>^(fixed : %M4A_LAG%ms^)
echo;

.\wavi.exe  %AUDIO_AVS% %FINAL_WAV% 1>nul 2>&1

rem m4aɃGR[h
:m4a_encode
if not exist %FINAL_WAV% goto wav_not_exist
echo;
echo ^>^>%WAV_END%
echo;
echo ^>^>%M4A_ENC_ANNOUNCE%
echo;
if /i "%AAC_ENCODER%"=="nero" (
    .\neroAacEnc.exe %AAC% -2pass -br %A_BITRATE%000 -if %FINAL_WAV% -of %TEMP_M4A%
) else if "%AAC%"=="-lc" (
    .\qtaacenc.exe --highest --cvbr %A_BITRATE% %FINAL_WAV% %TEMP_M4A%
) else (
    .\qtaacenc.exe --he --highest --cvbr %A_BITRATE% %FINAL_WAV% %TEMP_M4A%
)

:wav_not_exist
echo;
if not exist %TEMP_M4A% (
    echo ^>^>%WAV_ERROR%
    echo;
    copy /y mute.m4a %TEMP_DIR%\audio.m4a 1>nul 2>&1
)
echo ^>^>%M4A_SUCCESS%
echo;
